summary | shortlog | log | commit | commitdiff | tree
raw | patch | inline | side by side (parent: f0ebff0)
raw | patch | inline | side by side (parent: f0ebff0)
author | Amos Waterland <apw@rossby.metr.ou.edu> | |
Thu, 8 Sep 2005 02:13:26 +0000 (21:13 -0500) | ||
committer | Junio C Hamano <junkio@cox.net> | |
Thu, 8 Sep 2005 05:08:30 +0000 (22:08 -0700) |
If you run `git branch --help', you will unexpectedly have created a new
branch named "--help". This simple patch adds logic and a usage
statement to catch this and similar problems, and adds a testcase for it.
Signed-off-by: Amos Waterland <apw@rossby.metr.ou.edu>
Signed-off-by: Junio C Hamano <junkio@cox.net>
branch named "--help". This simple patch adds logic and a usage
statement to catch this and similar problems, and adds a testcase for it.
Signed-off-by: Amos Waterland <apw@rossby.metr.ou.edu>
Signed-off-by: Junio C Hamano <junkio@cox.net>
git-branch.sh | patch | blob | history | |
t/t3200-branch.sh | [new file with mode: 0755] | patch | blob |
diff --git a/git-branch.sh b/git-branch.sh
index 145a7b783a75f17dd00ff3adf9ef52170195e688..81b9e6cce138452ab50c1dee869b82a9f6706d34 100755 (executable)
--- a/git-branch.sh
+++ b/git-branch.sh
. git-sh-setup || die "Not a git archive"
+usage () {
+ echo >&2 "usage: $(basename $0)"' [<branchname> [start-point]]
+
+If no arguments, show available branches and mark current branch with a star.
+If one argument, create a new branch <branchname> based off of current HEAD.
+If two arguments, create a new branch <branchname> based off of <start-point>.
+'
+ exit 1
+}
+
case "$#" in
0)
headref=$(readlink "$GIT_DIR/HEAD" | sed -e 's|^refs/heads/||')
head="$2^0" ;;
esac
branchname="$1"
+
+case "$branchname" in
+-*)
+ usage;;
+esac
+
rev=$(git-rev-parse --verify "$head") || exit
[ -e "$GIT_DIR/refs/heads/$branchname" ] && die "$branchname already exists"
diff --git a/t/t3200-branch.sh b/t/t3200-branch.sh
--- /dev/null
+++ b/t/t3200-branch.sh
@@ -0,0 +1,27 @@
+#!/bin/sh
+#
+# Copyright (c) 2005 Amos Waterland
+#
+
+test_description='git branch --foo should not create bogus branch
+
+This test runs git branch --help and checks that the argument is properly
+handled. Specifically, that a bogus branch is not created.
+'
+. ./test-lib.sh
+
+test_expect_success \
+ 'prepare an trivial repository' \
+ 'echo Hello > A &&
+ ../../git-update-index --add A &&
+ ../../git-commit.sh -m "Initial commit."'
+
+test_expect_failure \
+ 'git branch --help should return error code' \
+ '../../git-branch.sh --help'
+
+test_expect_failure \
+ 'git branch --help should not have created a bogus branch' \
+ 'test -f .git/refs/heads/--help'
+
+test_done